﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace Janken
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

        Texture2D messageTexture;
        Texture2D computerTexture;
        Texture2D playerTexture;
        Texture2D xbuttonTexture;
        Texture2D ybuttonTexture;
        Texture2D bbuttonTexture;
        Texture2D computerHandTexture;
        Texture2D playerHandTexture;
        Texture2D stoneTexture;
        Texture2D scissorsTexture;
        Texture2D paperTexture;
        bool flg;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";

            graphics.PreferredBackBufferWidth = 1280;
            graphics.PreferredBackBufferHeight = 720;

        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            // TODO: use this.Content to load your game content here

            messageTexture = Content.Load<Texture2D>("message1");
            computerTexture = Content.Load<Texture2D>("computer");
            playerTexture = Content.Load<Texture2D>("player");
            computerHandTexture = Content.Load<Texture2D>("stone");
            playerHandTexture = Content.Load<Texture2D>("stone");
            xbuttonTexture = Content.Load<Texture2D>("xbutton");
            ybuttonTexture = Content.Load<Texture2D>("ybutton");
            bbuttonTexture = Content.Load<Texture2D>("bbutton");
            stoneTexture = Content.Load<Texture2D>("stone");
            scissorsTexture = Content.Load<Texture2D>("scissors");
            paperTexture = Content.Load<Texture2D>("paper");

        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();
            else
            {
                if (GamePad.GetState(PlayerIndex.One).Buttons.X == ButtonState.Pressed && flg == false)
                {
                    flg = true;
                    computerHandTexture = showHand();
                    playerHandTexture = Content.Load<Texture2D>("stone");
                    messageTexture = judge(playerHandTexture, computerHandTexture);
                }
                else if (GamePad.GetState(PlayerIndex.One).Buttons.Y == ButtonState.Pressed && flg == false)
                {
                    flg = true;
                    computerHandTexture = showHand();
                    playerHandTexture = Content.Load<Texture2D>("scissors");
                    messageTexture = judge(playerHandTexture, computerHandTexture);
                }
                else if (GamePad.GetState(PlayerIndex.One).Buttons.B == ButtonState.Pressed && flg == false)
                {
                    flg = true;
                    computerHandTexture = showHand();
                    playerHandTexture = Content.Load<Texture2D>("paper");
                    messageTexture = judge(playerHandTexture, computerHandTexture);
                }
                else if (GamePad.GetState(PlayerIndex.One).Buttons.A == ButtonState.Pressed && flg == true)
                {
                    flg = false;
                    computerHandTexture = Content.Load<Texture2D>("stone");
                    playerHandTexture = Content.Load<Texture2D>("stone");
                    messageTexture = Content.Load<Texture2D>("message1");
                }
            }

            // TODO: Add your update logic here

            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);

            // TODO: Add your drawing code here

            spriteBatch.Begin();
            spriteBatch.Draw(messageTexture, new Vector2(240, 30), Color.White);
            spriteBatch.Draw(computerTexture, new Vector2(240, 210), Color.White);
            spriteBatch.Draw(playerTexture, new Vector2(640, 210), Color.White);
            spriteBatch.Draw(computerHandTexture, new Vector2(240, 260), Color.White);
            spriteBatch.Draw(playerHandTexture, new Vector2(640, 260), Color.White);
            spriteBatch.Draw(xbuttonTexture, new Vector2(240, 470), Color.White);
            spriteBatch.Draw(ybuttonTexture, new Vector2(510, 470), Color.White);
            spriteBatch.Draw(bbuttonTexture, new Vector2(770, 470), Color.White);
            spriteBatch.End();

            base.Draw(gameTime);
        }
        private Texture2D showHand()
        {
            int i = new Random().Next(3);
            if (i == 0) return stoneTexture;
            else if (i == 1) return scissorsTexture;
            else return paperTexture;
        }
        private Texture2D judge(Texture2D playerHandTexture, Texture2D computerHandTexture)
        {
            if (playerHandTexture == computerHandTexture)
            {
                return Content.Load<Texture2D>("message4");
            }
            else if ((playerHandTexture == stoneTexture && computerHandTexture == scissorsTexture) ||
                    (playerHandTexture == scissorsTexture && computerHandTexture == paperTexture) ||
                    (playerHandTexture == paperTexture && computerHandTexture == stoneTexture))
            {
                return Content.Load<Texture2D>("message2");
            }
            else
            {
                return Content.Load<Texture2D>("message3");
            }
        }
    }
}
